\section{Project Summary}
\subsection{Overview} 
%Tell reviewers what your project is about and why it is unique.\\
\noindent A router data plane chip is a key component of a core router. The chip implements many core router functionalities such as IP lookup, packet classification, telemetry, queuing, explicit congestion control and so on. Existing router chips are developed using register transfer level (RTL) hardware description languages (HDL) such as Verilog or VHDL. However, designing an algorithm in RTL level HDL is extremely challenging. It requires hardware designers to use very low level circuit abstraction to implement the logic. It also requires hardware designers to keep track of the circuit path latencies so that operations are executed at the right time. Such tedious and complex process calls for designing hardware at a higher level. High-level synthesis (HLS) is a solution to this problem. High-level synthesis is a design methodology that generates Verilog RTL from a high-level language (such as C, C++) in correct-by-construction manner. Thus, it improves the designer productivity significantly. Currently, most of the open source HLS tools focus on FPGA, not ASIC. They also do not support pipelining, thus can not be used for line-rate packet processing needed in a high-speed router. We developed an \textbf{open source high-level synthesis tool} named C2RTL for \textbf{router chips} that supports \textbf{Pipelining} and \textbf{Control-Flow Intensive (CFI) applications}. The goal of this project is to develop a \textbf{an automated pipelining} that reduces area and power consumption. We also aim to add \textbf{broader router dataplane function support} in C2RTL. 

Keywords: High-level synthesis; Automated pipelining; Router dataplane algorithms

\subsection{Intellectual Merit} 
%\noindent Tell reviewers why your project is scientifically interesting.\\
\noindent Our C2RTL project broke a new ground by designing a High-level synthesis for router dataplane. Currently, C2RTL mainly focuses on generating pipelined RTL code for control flow intensive applications. However, it does not improve the area (and power). This project aims to  develop an automated pipelining mechanism that will reduce area (and power) without violating the clock speed. Brut-force mechanism for achieving such pipelining is very computationally expensive and currently done manually by existing tools. This is why, such automated pipelining algorithm has great scientific importance. 

Currently, C2RTL works for trie based IP lookup and packet classification algorithms. This also project aims to add support for other dataplane functions. Thus, it will produce some missing peaces needed for a routing chip.

\subsection{Broader Impacts of the Proposed Work} 
%\noindent Tell reviewers about other outcomes of your project beyond the science. Ideas include ancillary products, outreach, and more.
This project aims to simplify router chip development by developing an open source HLS tool for routers. This will improve the networking and high-level synthesis research ecosystem significantly.  The project will also develop curricular material to train graduate students in high-level synthesis and router data-plane algorithms.

%This project will enable us to design a router chip in C using a High-level synthesis tool. The project will also develop curricular material on high-level synthesis and high-performance routers. 